diff --git a/configure.in b/configure.in
--- a/configure.in
+++ b/configure.in
@@ -175,9 +175,7 @@
 #--------------------------------------------------------------------
 
 AC_ARG_WITH(iconv,
-changequote(<<, >>)dnl
-<<  --with-iconv[=DIR]        where to find iconv [system]>>dnl
-changequote([, ])dnl
+AS_HELP_STRING([--with-iconv[=DIR]], [where to find iconv [system]])
 )
 
 # Check for iconv
@@ -248,9 +246,7 @@
 #--------------------------------------------------------------------
 
 AC_ARG_WITH(freetype,
-changequote(<<, >>)dnl
-<<  --with-freetype[=ARG]     with freetype support [ARG=linked]>>dnl
-changequote([, ])dnl
+AS_HELP_STRING([--with-freetype[=ARG]], [with freetype support [ARG=linked]])
 )
 
 SAVE_CPPFLAGS="$CPPFLAGS"
@@ -298,9 +294,7 @@
 #--------------------------------------------------------------------
 
 AC_ARG_WITH(cairo,
-changequote(<<, >>)dnl
-<<  --with-cairo[=ARG]        with cairo support [ARG=no]>>dnl
-changequote([, ])dnl
+AS_HELP_STRING([--with-cairo[=ARG]], [with cairo support [ARG=no]])
 )
 
 SAVE_CPPFLAGS="$CPPFLAGS"
@@ -343,9 +337,7 @@
 #--------------------------------------------------------------------
 
 AC_ARG_WITH(imlib2,
-changequote(<<, >>)dnl
-<<  --with-imlib2[=ARG]       with imlib2 support [ARG=no]>>dnl
-changequote([, ])dnl
+AS_HELP_STRING([--with-imlib2[=ARG]], [with imlib2 support [ARG=no]])
 )
 
 SAVE_CPPFLAGS="$CPPFLAGS"
@@ -390,9 +382,7 @@
 #--------------------------------------------------------------------
 
 AC_ARG_WITH(axel,
-changequote(<<, >>)dnl
-<<  --with-axel[=ARG]         with axel support [ARG=no]>>dnl
-changequote([, ])dnl
+AS_HELP_STRING([--with-axel[=ARG]], [with axel support [ARG=no]])
 )
 
 SAVE_CPPFLAGS="$CPPFLAGS"
@@ -434,9 +424,7 @@
 #--------------------------------------------------------------------
 
 AC_ARG_WITH(gs,
-changequote(<<, >>)dnl
-<<  --with-gs[=ARG]           with ghostscript support [ARG=yes]>>dnl
-changequote([, ])dnl
+AS_HELP_STRING([--with-gs[=ARG]], [with ghostscript support [ARG=yes]])
 )
 
 if test "$with_gs" = "no" ; then
@@ -470,9 +458,7 @@
 #--------------------------------------------------------------------
 
 AC_ARG_WITH(sqlite3,
-changequote(<<, >>)dnl
-<<  --with-sqlite3[=ARG]      with sqlite3 support [ARG=no]>>dnl
-changequote([, ])dnl
+AS_HELP_STRING([--with-sqlite3[=ARG]], [with sqlite3 support [ARG=no]])
 )
 
 SAVE_CPPFLAGS="$CPPFLAGS"
@@ -514,9 +500,7 @@
 #--------------------------------------------------------------------
 
 AC_ARG_WITH(sparkle,
-changequote(<<, >>)dnl
-<<  --with-sparkle[=ARG]      with (Win)Sparkle autoupdater [ARG=no]>>dnl
-changequote([, ])dnl
+AS_HELP_STRING([--with-sparkle[=ARG]], [with (Win)Sparkle autoupdater [ARG=no]])
 )
 
 SAVE_OBJCFLAGS="$OBJCFLAGS"
@@ -910,7 +894,7 @@
 if test x"$CONFIG_OS" = xMACOS; then
 
 AC_ARG_ENABLE(macosx-extensions,
-[  --disable-macosx-extensions  do not use Mac specific services (spellchecker, image handling, ...)],
+AS_HELP_STRING([--disable-macosx-extensions], [do not use Mac specific services (spellchecker, image handling, ...)]),
     [], [enable_macosx_extensions="yes"])
 case "$enable_macosx_extensions" in
     yes)
@@ -936,9 +920,7 @@
 #--------------------------------------------------------------------
 
 AC_ARG_ENABLE(macosx-distr,
-changequote(<<, >>)dnl
-<<  --enable-macosx-distr[=ARCH]   build for MacOSX >= 10.4 and arch [ARCH]>>,
-changequote([, ])dnl
+AS_HELP_STRING([--enable-macosx-distr[=ARCH]], [build for MacOSX >= 10.4 and arch [ARCH]]),
 [], [enable_macosx_distr="no"])
 
 if test "$enable_macosx_distr" != "no" ; then    
@@ -1209,9 +1191,7 @@
 esac
 
 AC_ARG_ENABLE(debug,
-changequote(<<, >>)dnl
-<<  --enable-debug[=ARG]      install a debugging enable executable [-ggdb]>>,
-changequote([, ])dnl
+AS_HELP_STRING([--enable-debug[=ARG]], [install a debugging enable executable [-ggdb]]),
 [], [enable_debug="no"])
 
 if test "$enable_debug" = "yes"; then
@@ -1235,9 +1215,7 @@
 fi
 
 AC_ARG_ENABLE(assert,
-changequote(<<, >>)dnl
-<<  --enable-assert         exit on failed assertions in code>>,
-changequote([, ])dnl
+AS_HELP_STRING([--enable-assert], [exit on failed assertions in code]),
 [], [enable_assert="yes"])
 
 if test "$enable_assert" = "no"; then
@@ -1298,9 +1276,7 @@
 fi
 
 AC_ARG_ENABLE(optimize,
-changequote(<<, >>)dnl
-<<  --enable-optimize[=ARG]   compile with optimizations [guessed]>>,
-changequote([, ])dnl
+AS_HELP_STRING([--enable-optimize[=ARG]], [compile with optimizations [guessed]]),
 [], [enable_optimize="$optimize_default"])
 
 case "$enable_optimize" in